require 'magloft'
require "workspace"
require "workspace-parse"
require "maglove/theme"
require "maglove/engine"
require "maglove/commands/base"
require "maglove/commands/fonts"
require "maglove/commands/theme"
require "maglove/commands/assets"
require "maglove/commands/main"

module Maglove
  def self.theme
    Theme.instance
  end

  def self.assets_dir
    @assets_dir ||= begin
      spec = Gem::Specification.find_by_name("maglove")
      Workspace::Dir.new(spec.gem_dir).dir("assets")
    end
  end

  def self.logger
    if @logger.nil?
      Logging.color_scheme("bright", {
        levels: { debug: :blue, info: :green, warn: :yellow, error: :red, fatal: [:white, :on_red] },
        date: :blue,
        mdc: :cyan,
        logger: :cyan,
        message: :black
      })
      Logging.appenders.stdout("stdout", layout: Logging.layouts.pattern(pattern: '[%d] %-5l %-18X{full_command} %x %m\n', color_scheme: 'bright'))
      @logger = Logging::Logger.new(self.class.name)
      @logger.level = :debug
      @logger.add_appenders('stdout')
    end
    @logger
  end
end
