module Maglove
  class Theme
    include Singleton
    attr_reader :identifier, :name, :base_version, :description, :templates, :fonts, :widgets
    attr_reader :src_dir, :dist_dir, :base_dir

    def loaded?
      !identifier.nil?
    end

    def load(identifier)
      yaml = Workspace::Dir.new(Dir.pwd, "src/themes/#{identifier}").file("theme.yml").read_yaml
      # theme properties
      @identifier = yaml["identifier"]
      @name = yaml["name"]
      @base_version = yaml["base_version"]
      @description = yaml["description"]
      @templates = yaml["templates"]
      @fonts = yaml["fonts"]
      @widgets = yaml["widgets"]
      # directories
      @src_dir = Workspace.dir(File.join(Dir.pwd, "src/themes/#{@identifier}"))
      @dist_dir = Workspace.dir(File.join(Dir.pwd, "dist/themes/#{@identifier}"))
      @base_dir = Workspace.dir(File.join(Dir.pwd, "src/base/#{@base_version}"))
    end
  end
end
